import request from "request";

exports.handler = (context, done) => {
    const config = context.config;

    const options = {
        json: true,
        method: config.method,
        url: config.url
    };

    if (config.body)
        options.body = JSON.parse(config.body);
    if (config.params)
        options.qs = JSON.parse(config.params);
    if (config.headers)
        options.headers = JSON.parse(config.headers);

    request(options, (err, response, body) => {
        // clear previous status
        context.vars.unset(config.variable);

        if (response.statusCode  === 500){
            console.log("JSON API: There has been some issues processing your request. Please check your API provider for more information.");
        }
        else if (response.statusCode < 200 || response.statusCode > 299){
            console.log(body);
        }
        else if (config.variable){
            context.vars.set(config.variable, body);
        }
            
        done();
    });
}