import { Bot } from './bot-model';
export interface Log {
    incoming(body: object): any;
    outgoing(reqData: any, body: object): any;
}
export declare abstract class RecimeLogger implements Log {
    private bot;
    abstract readonly platform: any;
    constructor(bot: Bot);
    incoming(body: any): void;
    outgoing(reqData: any, body: any): void;
    sendRequest(body: any): Promise<{}>;
}
export declare class BotFrameworkLogger extends RecimeLogger {
    readonly platform: string;
}
export declare class FacebookLogger extends RecimeLogger {
    readonly platform: string;
}
export declare class TelegramLogger extends RecimeLogger {
    readonly platform: string;
}
export declare class SlackLogger extends RecimeLogger {
    readonly platform: string;
}
export declare class SendBirdLogger extends RecimeLogger {
    readonly platform: string;
}
export declare class TwilioLogger extends RecimeLogger {
    readonly platform: string;
}
export declare class ViberLogger extends RecimeLogger {
    readonly platform: string;
}
export declare class WeChatLogger extends RecimeLogger {
    readonly platform: string;
}
export declare class WebLogger extends RecimeLogger {
    readonly platform: string;
}
